c      program testait
      subroutine testait

      print*,'glong,glat,aitx,aity'
      do ib=-9,8
         do il=-18,17
            glat= (real(ib)+0.5)*10.0
            glong= (real(il)+0.5)*10.0
            call aitcoord(glong,glat,aitx,aity)
            call aitinvert(aitx,aity,gl2,gb2)
            if(abs(gl2-glong)+abs(gb2-glat).lt.1.0)then
               print*,glong,glat,aitx,aity, gl2,gb2
            else
               print*,glong,glat,aitx,aity, gl2,gb2,' !!!!'
            endif
         enddo
      enddo

      do while(1+1.eq.2)
         print*,'Enter aitx,aity :'
         read(5,*,end=666)aitx,aity
         call aitinvert(aitx,aity,gl,gb)
         print*,aitx,aity,gl,gb
         call aitcoord(gl,gb,aitx,aity)
         print*,gl,gb,aitx,aity
      enddo
 666  continue
      end



c     From a.liddle@ic.ac.uk  Mon Oct 19 16:38:38 1998
c     From: Andrew Liddle <a.liddle@ic.ac.uk>
c     To: Boud Roukema <boud@munster.iucaa.ernet.in>
c
c     
c     My stuff is a mess but I found a code for the AITOFF projection,
c     attached below. I can't remember how to use it though. I also recall
c     that the variable ranges are half what you expect, so you have to be
c     careful.
c     
c     The routine is described in the IRAS PSC documentation.
c     
c     cheers,
c     
c     Andrew
c     
c ***************************************************************
c
      subroutine aitcoord(galon,galat,aitx,aity)
c
      implicit real(a-h,o-z)
c      parameter(pi=3.14159265359)
c      parameter(pi_180= pi/180.0)
c      parameter(sc_100= 90.0/sqrt(2.0))
c      scale=pi

      sc_100= 90.0/sqrt(2.0)
c
c      common/aitconst/scale
c
c ******* convert galon and galat to rho and theta *******
c ******* first check range is ok
      if(galon.gt.180.0)galon = galon - 360.0
c
      rho = acosd(cosd(galat)*cosd(galon/2.0))
      if(rho.eq.0.0)then
           the = 0.0
      else
           sinthe = (cosd(galat)*sind(galon/2.0))/sind(rho)
           if(sinthe.gt.1.0)sinthe = 1.0
           if(sinthe.lt.-1.0)sinthe = -1.0
           the = asind(sinthe)
      endif
c
c ******* finally convert to x and y *******
      aitx = -4.0*sc_100 *sind(rho/2.0)*sind(the)
      ycoo = 2.0*sc_100 *sind(rho/2.0)*cosd(the)
      if(galat.lt.0.0)aity = -ycoo
      if(galat.ge.0.0)aity = ycoo
      return
      end



      subroutine aitinvert(aitx,aity,glong,glat)
c     ==== written B. Roukema 21/06/99 IAP ====
c      parameter(pi=3.14159265359)
c      parameter(pi_180= pi/180.0)
      parameter(tol=1e-6)
c      parameter(sc_100= 90.0/sqrt(2.0))
c      scale=pi

      sc_100= 90.0/sqrt(2.0)

      if(abs(sc_100).lt.tol)print*,
     _     'aitinvert: WARNING:  sc_100=',sc_100

      srho_2 = sqrt( aitx*aitx/16.0/sc_100/sc_100
     _     + aity*aity/4.0/sc_100/sc_100 )

      if(srho_2.ge.1.0)srho_2 = 1.0 -tol
      if(srho_2.le.-1.0)srho_2 = -1.0 +tol
      rho_2 = asind(srho_2)     ! * -1 or * +1 ?

      if(abs(aity).gt.tol)then
         sinth= sind( atand( -0.5*aitx/aity ) )
      else
         sinth= 1.0
      endif
      if(aity.lt.0.0)sinth=-sinth

      tandl_2= tand(2.0*rho_2) * sinth
      glong= 2.0* atand( tandl_2 )

      crho= cosd(2.0*rho_2)      
      srho= sind(2.0*rho_2)      
      cosb= sqrt( crho*crho + sinth*sinth*srho*srho )
      if(cosb.ge.1.0)cosb = 1.0 -tol
      if(cosb.le.-1.0)cosb = -1.0 +tol

      glat= acosd(cosb)
      if(aity.lt.0.0)glat=-glat

      return
      end

