c      program testbess
      subroutine testbess
      real*8  bi0d,y,z
      real*4  x
      write(6,'(a,$)')'Enter x: '
      read(5,*)x
      print*,'x,dble(x),1.0d0*x=',x,dble(x),1.0d0*x
      y=dble(x)
      z=bi0d(y)
      print*,'z=',z
      print*,'bessi0(x),bi0d(dble(x)), '
     _     //'exp(x)/sqrt(2.0*3.1416*x)=',
     _     bessi0(x),bi0d(dble(x)), exp(x)/sqrt(2.0*3.1416*x)
      end




      real*4 function bessi0 (x)
c     -----------------------
c     
      real    x,ax
      real*8  y,p1,p2,p3,p4,p5,p6,p7,q1,q2,q3,q4,q5,q6,q7,q8,q9
c     
      data  p1,p2,p3,p4,p5,p6,p7/1.0d0,3.5156229d0,3.0899424d0,
     *     1.2067492d0,0.2659732d0,0.360768d-1,0.45813d-2/
      data  q1,q2,q3,q4,q5,q6,q7,q8,q9/0.39894228d0,0.1328592d-1,
     *     0.225319d-2,-0.157565d-2,0.916281d-2,-0.2057706d-1,
     *     0.2635537d-1,-0.1647633d-1,0.392377d-2/
c     
      if (abs(x).lt.3.75) then
         y=(x/3.75)**2
         bessi0=p1+y*(p2+y*(p3+y*(p4+y*(p5+y*(p6+y*p7))))) 
      else
         ax=abs(x)
         y=3.75/ax
         bessi0= (exp(ax)/sqrt(ax))*(q1+y*(q2+y*(q3+y*(q4
     *        +y*(q5+y*(q6+y*(q7+y*(q8+y*q9))))))))   
      endif
      return
      end

      real*8 function bi0d (x)
c     -----------------------
c     
      real*8   x,ax
      real*8  y,p1,p2,p3,p4,p5,p6,p7,q1,q2,q3,q4,q5,q6,q7,q8,q9
c     
      data  p1,p2,p3,p4,p5,p6,p7/1.0d0,3.5156229d0,3.0899424d0,
     *     1.2067492d0,0.2659732d0,0.360768d-1,0.45813d-2/
      data  q1,q2,q3,q4,q5,q6,q7,q8,q9/0.39894228d0,0.1328592d-1,
     *     0.225319d-2,-0.157565d-2,0.916281d-2,-0.2057706d-1,
     *     0.2635537d-1,-0.1647633d-1,0.392377d-2/
c     
      if (abs(x).lt.3.75) then
         y=(x/3.75)**2
         bi0d=p1+y*(p2+y*(p3+y*(p4+y*(p5+y*(p6+y*p7))))) 
      else
         ax=abs(x)
         y=3.75/ax
         bi0d= (exp(ax)/sqrt(ax))*(q1+y*(q2+y*(q3+y*(q4
     *        +y*(q5+y*(q6+y*(q7+y*(q8+y*q9))))))))   
      endif
      return
      end

      real*8 function bi0dexp (x) ! modified bessel function I_0 divided by
c     -----------------------   the exponential of abs value of x
c     
      real*8   x,ax
      real*8  y,p1,p2,p3,p4,p5,p6,p7,q1,q2,q3,q4,q5,q6,q7,q8,q9
c     
      data  p1,p2,p3,p4,p5,p6,p7/1.0d0,3.5156229d0,3.0899424d0,
     *     1.2067492d0,0.2659732d0,0.360768d-1,0.45813d-2/
      data  q1,q2,q3,q4,q5,q6,q7,q8,q9/0.39894228d0,0.1328592d-1,
     *     0.225319d-2,-0.157565d-2,0.916281d-2,-0.2057706d-1,
     *     0.2635537d-1,-0.1647633d-1,0.392377d-2/
c     
      if (abs(x).lt.3.75) then
         y=(x/3.75)**2
         bi0dexp=p1+y*(p2+y*(p3+y*(p4+y*(p5+y*(p6+y*p7))))) 
     _        /exp(abs(x))
         
      else
         ax=abs(x)
         y=3.75/ax
         bi0dexp= (1.0d0/sqrt(ax))*(q1+y*(q2+y*(q3+y*(q4
     *        +y*(q5+y*(q6+y*(q7+y*(q8+y*q9))))))))   
      endif
      return
      end
