      subroutine bilin99(X1A,X2A,YA,M,N,X1,X2,Y)
c     === bilinear interpolation/extrapolation a la num.rec. ====
c     16/8/93  "null" value of  -99.9  added -  if any of the four
c     "corner"  values are <= -99.9, the interpolated value is also set 
c     to have this value.

      integer*4    m,n
      real*4       x1a(m),x2a(n),ya(m,n),x1,x2,y
      real*4       ynull
      parameter(ynull=-99.9)

      call hunt(x1a,m,x1,j)
      if(j.eq.0)j=1
      if(j.eq.m)j=m-1
      call hunt(x2a,n,x2,k)
      if(k.eq.0)k=1
      if(k.eq.n)k=n-1

      y1=ya(j,k)
      y2=ya(j+1,k)
      y3=ya(j+1,k+1)
      y4=ya(j,k+1)
      
      t=(x1-x1a(j)) / (x1a(j+1)-x1a(j))
      u=(x2-x2a(k)) / (x2a(k+1)-x2a(k))

      y=(1.0-t)*(1.0-u)*y1 + t*(1.0-u)*y2 + t*u*y3 + (1.0-t)*u*y4

      if((y1.le.ynull).or.(y2.le.ynull).or.(y3.le.ynull).or.
     _     (y4.le.ynull)) y=ynull
      return
      end
