      program constantes
c     ==== this is for playing numerology games like Eddington, 
c     Dirac and Francis Sanchez from Orsay ====

      implicit real*8 (a-m,o-z)

c     --- most of these values are just from neural memory ---
      c=2.9974952d8             ! SI

      mp=1.67d-27               ! SI
c      me=3.11d-31               ! SI
      me=9.11d-31               ! SI
      h=6.63d-34                !SI
c      G= 6.67d-11               !SI
      G= 6.673d-11               !SI
      pi=3.1415926536

      do i=1,2
         if(i.eq.1)then
            m= exp(1.0/3.0*log(mp*mp*me))
         else
            m= me*exp(1.0/3.0*log(1836.15*1838.68))
         endif

         hbar= h/(2.0d0*pi)
         

         print*,'m,h,hbar,G=',m,h,hbar,G
         print*,' '
         print*,'relativistic units: '
         print*,'m, hG/c^3, G/G=',
     _        m,
     _        h*G/c/c/c,
     _        G/G

         print*,' '
         print*,'h^2/(GM^3)=',h*h/G/M/M/M
         print*,'hbar^2/(GM^3)=',hbar*hbar/G/M/M/M
         print*,'2.0*hbar^2/(GM^3)=',2.0*hbar*hbar/G/M/M/M

         print*,'10h_100^-1 Gpc=',10.0 *1d9 *3.022d16,' h_100^-1 m'
         print*,'10h_70^-1 Gpc=',10.0 *1d9 *3.022d16 /0.70,' m'

         print*,'c/H_0 (h_70=1)=',c/(0.70* 100.0*1d3/3.022d22),' m'

      enddo

      end

