c      program testbicub
      subroutine testbicub
c     ==== tests bicubic spline (splie and splin2) ====

      parameter(m=10,n=3)
      real*4  x1a(m),x2a(n),ya(m,n),y2a(n)
      real*4  myfun

c     ---- function is   y(x1,x2)= x1^2 + x2, so bicubic spline should
c     give exact interpolation ----

      do im=1,m
         x1a(im)=real(im)
         do in=1,n
            x2a(in)=real(in)
            ya(im,in)=myfun(real(im),real(in))
         enddo
      enddo
         
      call splie2(x1a,x2a,ya,m,n,y2a)

      do while(1+1.eq.2)
         write(6,'(a,$)')'Enter  x1,x2: '
         read(5,*)x1,x2
         call splin2(x1a,x2a,ya,y2a,m,n,x1,x2,y)
         print*,'Interpolation is y=',y,'  value should be',
     _        myfun(x1,x2)
      enddo
      end

      real*4 function myfun(x1,x2)
      real*4 x1,x2
      myfun=x1*x1*x1 +0.2 *x2*(x2-7.8)*(x2+1.9)
      return
      end

c      subroutine  splicubic(x1a,x2a,ya,y2a,,x1,x2,y)
c     ==== combination spline in  m  direction,  cubic fit in  n direction ====
      
