c      program testfour
      subroutine testfour

      parameter(maxn=128)
c      real*4  tt(-maxn/2:maxn)
c      real*4  xx(maxn),xf(-maxn/2:maxn)
      real*4  tt(maxn),tnu(-maxn/2:maxn/2)
      real*4  xx(maxn),xf(-maxn/2:maxn/2)
      complex xxc(maxn)

c      do i=-maxn/2,maxn
      do i=1,maxn
         tt(i)=real(i)
         xx(i)=sin(tt(i)*2.0*3.1416/5.0)*0.5 +0.5
         xx(i)= xx(i)*xx(i)*xx(i)*xx(i)
         xxc(i)=xx(i)
      enddo
      
      call pgbegin(0,'?',1,1)
      call pgvsize(1.0,7.0,1.0,7.0)
      call pgwindow(0.0,tt(maxn),-0.05,1.05)
      call pgbox('bcnts',0.,0,'bcnts',0.,0)
      call pgline(maxn,tt(1),xx)
      call pgend

      call four1(xxc,maxn,1)
      bmax2=-9e9
c      do i=0,maxn/2 -1
c         xf(i)=real(xxc(i+1))
c         xf(i-maxn/2)=real(xxc(i+maxn/2 +1  ))
c         bmax2=max(xf(i),xf(i-maxn/2),bmax2)
c      enddo 
      do i=1,maxn/2 -1
         tnu(i)=real(i)/tt(maxn) 
         tnu(-i)=real(-i)/tt(maxn) 
c         xf(i)=real(xxc(i+1))
c         xf(i-maxn/2)= real(xxc(i+1+maxn/2))
         xf(i)=abs(xxc(i+1))
         xf(i-maxn/2)= abs(xxc(i+1+maxn/2))
         bmax2=max(xf(i),xf(i-maxn/2),bmax2)
      enddo
      tnu(0)=0.0
c      xf(0)=real(xxc(1))
      xf(0)=abs(xxc(1))
      bmax2=max(xf(0),bmax2)
      
      call pgbegin(0,'?',1,1)
      call pgvsize(1.0,7.0,1.0,7.0)
      call pgwindow(0.0,tt(maxn),-0.05,1.05)
      call pgbox('bcnts',0.,0,'bcnts',0.,0)
      call pgline(maxn,tt(1),xx)
      call pgend

      call pgbegin(0,'?',1,1)
      call pgvsize(1.0,7.0,1.0,7.0)
c      call pgwindow(tt(maxn/2),tt(maxn/2),0.0,bmax2*1.05)
c      call pgwindow(tnu(-maxn/2+1),tnu(maxn/2-1),-bmax2*1.05,bmax2*1.05)
      call pgwindow(-0.5,0.5,-bmax2*1.05,bmax2*1.05)
      call pgbox('bcnts',0.,0,'bcnts',0.,0)
c      call pgline(maxn,tt(-maxn/2),xf(-maxn/2))
c      call pgline(maxn,tt,xf)
      call pgline(maxn-1,tnu(-maxn/2+1),xf(-maxn/2+1))
      call pgend
      
      end

      






      SUBROUTINE four1(data,nn,isign)
      INTEGER isign,nn
      REAL data(2*nn)
      INTEGER i,istep,j,m,mmax,n
      REAL tempi,tempr
      DOUBLE PRECISION theta,wi,wpi,wpr,wr,wtemp
      n=2*nn
      j=1
      do 11 i=1,n,2
        if(j.gt.i)then
          tempr=data(j)
          tempi=data(j+1)
          data(j)=data(i)
          data(j+1)=data(i+1)
          data(i)=tempr
          data(i+1)=tempi
        endif
        m=n/2
1       if ((m.ge.2).and.(j.gt.m)) then
          j=j-m
          m=m/2
        goto 1
        endif
        j=j+m
11    continue
      mmax=2
2     if (n.gt.mmax) then
        istep=2*mmax
        theta=6.28318530717959d0/(isign*mmax)
        wpr=-2.d0*sin(0.5d0*theta)**2
        wpi=sin(theta)
        wr=1.d0
        wi=0.d0
        do 13 m=1,mmax,2
          do 12 i=m,n,istep
            j=i+mmax
            tempr=sngl(wr)*data(j)-sngl(wi)*data(j+1)
            tempi=sngl(wr)*data(j+1)+sngl(wi)*data(j)
            data(j)=data(i)-tempr
            data(j+1)=data(i+1)-tempi
            data(i)=data(i)+tempr
            data(i+1)=data(i+1)+tempi
12        continue
          wtemp=wr
          wr=wr*wpr-wi*wpi+wr
          wi=wi*wpr+wtemp*wpi+wi
13      continue
        mmax=istep
      goto 2
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software )!0.
