      program taylorseries
c     ==== quick and dirty check on expx convergence formula ====

      real*8  expx,x,term,tol

      parameter(tol=1d-4)

      do while(1+1.eq.2)
         print*,'Enter x,n:'
         read(5,*)x,n
         print*,'x,n=',x,n

         expx=0.0d0
         
         do i=0,n
            if(x.gt.tol)then
               term= exp(dble(i)*log(x))         
            elseif(x.lt.-tol)then
               if(2*(i/2).eq.i)then
                  term=  exp(dble(i)*log(-x))         
               else
                  term= - exp(dble(i)*log(-x))         
               endif
            else
               term=0.0d0 
               print*,'warning: abs(x) < tol !!'
            endif

            do j=2,i
               term=term/dble(j)
            enddo
            expx=expx+ term
         enddo

         print*,'x,exp(x),expx=',x,exp(x),expx

         write(6,'(a,f7.2,a)')
     _        'perc error=', 
     _        100.0*((abs(exp(x)-expx)/exp(x))),'%'
      enddo

      end

